use winit::VirtualKeyCode;

#[derive(Serialize, Deserialize)]
#[serde(remote = "VirtualKeyCode")]
pub enum LocalVirtualKeyCode {
    Key1,
    Key2,
    Key3,
    Key4,
    Key5,
    Key6,
    Key7,
    Key8,
    Key9,
    Key0,
    A,
    B,
    C,
    D,
    E,
    F,
    G,
    H,
    I,
    J,
    K,
    L,
    M,
    N,
    O,
    P,
    Q,
    R,
    S,
    T,
    U,
    V,
    W,
    X,
    Y,
    Z,
    Escape,
    F1,
    F2,
    F3,
    F4,
    F5,
    F6,
    F7,
    F8,
    F9,
    F10,
    F11,
    F12,
    F13,
    F14,
    F15,
    Snapshot,
    Scroll,
    Pause,
    Insert,
    Home,
    Delete,
    End,
    PageDown,
    PageUp,
    Left,
    Up,
    Right,
    Down,
    Back,
    Return,
    Space,
    Compose,
    Numlock,
    Numpad0,
    Numpad1,
    Numpad2,
    Numpad3,
    Numpad4,
    Numpad5,
    Numpad6,
    Numpad7,
    Numpad8,
    Numpad9,
    AbntC1,
    AbntC2,
    Add,
    Apostrophe,
    Apps,
    At,
    Ax,
    Backslash,
    Calculator,
    Capital,
    Colon,
    Comma,
    Convert,
    Decimal,
    Divide,
    Equals,
    Grave,
    Kana,
    Kanji,
    LAlt,
    LBracket,
    LControl,
    LMenu,
    LShift,
    LWin,
    Mail,
    MediaSelect,
    MediaStop,
    Minus,
    Multiply,
    Mute,
    MyComputer,
    NavigateForward,
    NavigateBackward,
    NextTrack,
    NoConvert,
    NumpadComma,
    NumpadEnter,
    NumpadEquals,
    OEM102,
    Period,
    PlayPause,
    Power,
    PrevTrack,
    RAlt,
    RBracket,
    RControl,
    RMenu,
    RShift,
    RWin,
    Semicolon,
    Slash,
    Sleep,
    Stop,
    Subtract,
    Sysrq,
    Tab,
    Underline,
    Unlabeled,
    VolumeDown,
    VolumeUp,
    Wake,
    WebBack,
    WebFavorites,
    WebForward,
    WebHome,
    WebRefresh,
    WebSearch,
    WebStop,
    Yen,
}

impl From<LocalVirtualKeyCode> for VirtualKeyCode {
    fn from(remote: LocalVirtualKeyCode) -> VirtualKeyCode {
        match remote {
            LocalVirtualKeyCode::Key1 => VirtualKeyCode::Key1,
            LocalVirtualKeyCode::Key2 => VirtualKeyCode::Key2,
            LocalVirtualKeyCode::Key3 => VirtualKeyCode::Key3,
            LocalVirtualKeyCode::Key4 => VirtualKeyCode::Key4,
            LocalVirtualKeyCode::Key5 => VirtualKeyCode::Key5,
            LocalVirtualKeyCode::Key6 => VirtualKeyCode::Key6,
            LocalVirtualKeyCode::Key7 => VirtualKeyCode::Key7,
            LocalVirtualKeyCode::Key8 => VirtualKeyCode::Key8,
            LocalVirtualKeyCode::Key9 => VirtualKeyCode::Key9,
            LocalVirtualKeyCode::Key0 => VirtualKeyCode::Key0,
            LocalVirtualKeyCode::A => VirtualKeyCode::A,
            LocalVirtualKeyCode::B => VirtualKeyCode::B,
            LocalVirtualKeyCode::C => VirtualKeyCode::C,
            LocalVirtualKeyCode::D => VirtualKeyCode::D,
            LocalVirtualKeyCode::E => VirtualKeyCode::E,
            LocalVirtualKeyCode::F => VirtualKeyCode::F,
            LocalVirtualKeyCode::G => VirtualKeyCode::G,
            LocalVirtualKeyCode::H => VirtualKeyCode::H,
            LocalVirtualKeyCode::I => VirtualKeyCode::I,
            LocalVirtualKeyCode::J => VirtualKeyCode::J,
            LocalVirtualKeyCode::K => VirtualKeyCode::K,
            LocalVirtualKeyCode::L => VirtualKeyCode::L,
            LocalVirtualKeyCode::M => VirtualKeyCode::M,
            LocalVirtualKeyCode::N => VirtualKeyCode::N,
            LocalVirtualKeyCode::O => VirtualKeyCode::O,
            LocalVirtualKeyCode::P => VirtualKeyCode::P,
            LocalVirtualKeyCode::Q => VirtualKeyCode::Q,
            LocalVirtualKeyCode::R => VirtualKeyCode::R,
            LocalVirtualKeyCode::S => VirtualKeyCode::S,
            LocalVirtualKeyCode::T => VirtualKeyCode::T,
            LocalVirtualKeyCode::U => VirtualKeyCode::U,
            LocalVirtualKeyCode::V => VirtualKeyCode::V,
            LocalVirtualKeyCode::W => VirtualKeyCode::W,
            LocalVirtualKeyCode::X => VirtualKeyCode::X,
            LocalVirtualKeyCode::Y => VirtualKeyCode::Y,
            LocalVirtualKeyCode::Z => VirtualKeyCode::Z,
            LocalVirtualKeyCode::Escape => VirtualKeyCode::Escape,
            LocalVirtualKeyCode::F1 => VirtualKeyCode::F1,
            LocalVirtualKeyCode::F2 => VirtualKeyCode::F2,
            LocalVirtualKeyCode::F3 => VirtualKeyCode::F3,
            LocalVirtualKeyCode::F4 => VirtualKeyCode::F4,
            LocalVirtualKeyCode::F5 => VirtualKeyCode::F5,
            LocalVirtualKeyCode::F6 => VirtualKeyCode::F6,
            LocalVirtualKeyCode::F7 => VirtualKeyCode::F7,
            LocalVirtualKeyCode::F8 => VirtualKeyCode::F8,
            LocalVirtualKeyCode::F9 => VirtualKeyCode::F9,
            LocalVirtualKeyCode::F10 => VirtualKeyCode::F10,
            LocalVirtualKeyCode::F11 => VirtualKeyCode::F11,
            LocalVirtualKeyCode::F12 => VirtualKeyCode::F12,
            LocalVirtualKeyCode::F13 => VirtualKeyCode::F13,
            LocalVirtualKeyCode::F14 => VirtualKeyCode::F14,
            LocalVirtualKeyCode::F15 => VirtualKeyCode::F15,
            LocalVirtualKeyCode::Snapshot => VirtualKeyCode::Snapshot,
            LocalVirtualKeyCode::Scroll => VirtualKeyCode::Scroll,
            LocalVirtualKeyCode::Pause => VirtualKeyCode::Pause,
            LocalVirtualKeyCode::Insert => VirtualKeyCode::Insert,
            LocalVirtualKeyCode::Home => VirtualKeyCode::Home,
            LocalVirtualKeyCode::Delete => VirtualKeyCode::Delete,
            LocalVirtualKeyCode::End => VirtualKeyCode::End,
            LocalVirtualKeyCode::PageDown => VirtualKeyCode::PageDown,
            LocalVirtualKeyCode::PageUp => VirtualKeyCode::PageUp,
            LocalVirtualKeyCode::Left => VirtualKeyCode::Left,
            LocalVirtualKeyCode::Up => VirtualKeyCode::Up,
            LocalVirtualKeyCode::Right => VirtualKeyCode::Right,
            LocalVirtualKeyCode::Down => VirtualKeyCode::Down,
            LocalVirtualKeyCode::Back => VirtualKeyCode::Back,
            LocalVirtualKeyCode::Return => VirtualKeyCode::Return,
            LocalVirtualKeyCode::Space => VirtualKeyCode::Space,
            LocalVirtualKeyCode::Compose => VirtualKeyCode::Compose,
            LocalVirtualKeyCode::Numlock => VirtualKeyCode::Numlock,
            LocalVirtualKeyCode::Numpad0 => VirtualKeyCode::Numpad0,
            LocalVirtualKeyCode::Numpad1 => VirtualKeyCode::Numpad1,
            LocalVirtualKeyCode::Numpad2 => VirtualKeyCode::Numpad2,
            LocalVirtualKeyCode::Numpad3 => VirtualKeyCode::Numpad3,
            LocalVirtualKeyCode::Numpad4 => VirtualKeyCode::Numpad4,
            LocalVirtualKeyCode::Numpad5 => VirtualKeyCode::Numpad5,
            LocalVirtualKeyCode::Numpad6 => VirtualKeyCode::Numpad6,
            LocalVirtualKeyCode::Numpad7 => VirtualKeyCode::Numpad7,
            LocalVirtualKeyCode::Numpad8 => VirtualKeyCode::Numpad8,
            LocalVirtualKeyCode::Numpad9 => VirtualKeyCode::Numpad9,
            LocalVirtualKeyCode::AbntC1 => VirtualKeyCode::AbntC1,
            LocalVirtualKeyCode::AbntC2 => VirtualKeyCode::AbntC2,
            LocalVirtualKeyCode::Add => VirtualKeyCode::Add,
            LocalVirtualKeyCode::Apostrophe => VirtualKeyCode::Apostrophe,
            LocalVirtualKeyCode::Apps => VirtualKeyCode::Apps,
            LocalVirtualKeyCode::At => VirtualKeyCode::At,
            LocalVirtualKeyCode::Ax => VirtualKeyCode::Ax,
            LocalVirtualKeyCode::Backslash => VirtualKeyCode::Backslash,
            LocalVirtualKeyCode::Calculator => VirtualKeyCode::Calculator,
            LocalVirtualKeyCode::Capital => VirtualKeyCode::Capital,
            LocalVirtualKeyCode::Colon => VirtualKeyCode::Colon,
            LocalVirtualKeyCode::Comma => VirtualKeyCode::Comma,
            LocalVirtualKeyCode::Convert => VirtualKeyCode::Convert,
            LocalVirtualKeyCode::Decimal => VirtualKeyCode::Decimal,
            LocalVirtualKeyCode::Divide => VirtualKeyCode::Divide,
            LocalVirtualKeyCode::Equals => VirtualKeyCode::Equals,
            LocalVirtualKeyCode::Grave => VirtualKeyCode::Grave,
            LocalVirtualKeyCode::Kana => VirtualKeyCode::Kana,
            LocalVirtualKeyCode::Kanji => VirtualKeyCode::Kanji,
            LocalVirtualKeyCode::LAlt => VirtualKeyCode::LAlt,
            LocalVirtualKeyCode::LBracket => VirtualKeyCode::LBracket,
            LocalVirtualKeyCode::LControl => VirtualKeyCode::LControl,
            LocalVirtualKeyCode::LMenu => VirtualKeyCode::LMenu,
            LocalVirtualKeyCode::LShift => VirtualKeyCode::LShift,
            LocalVirtualKeyCode::LWin => VirtualKeyCode::LWin,
            LocalVirtualKeyCode::Mail => VirtualKeyCode::Mail,
            LocalVirtualKeyCode::MediaSelect => VirtualKeyCode::MediaSelect,
            LocalVirtualKeyCode::MediaStop => VirtualKeyCode::MediaStop,
            LocalVirtualKeyCode::Minus => VirtualKeyCode::Minus,
            LocalVirtualKeyCode::Multiply => VirtualKeyCode::Multiply,
            LocalVirtualKeyCode::Mute => VirtualKeyCode::Mute,
            LocalVirtualKeyCode::MyComputer => VirtualKeyCode::MyComputer,
            LocalVirtualKeyCode::NavigateForward => VirtualKeyCode::NavigateForward,
            LocalVirtualKeyCode::NavigateBackward => VirtualKeyCode::NavigateBackward,
            LocalVirtualKeyCode::NextTrack => VirtualKeyCode::NextTrack,
            LocalVirtualKeyCode::NoConvert => VirtualKeyCode::NoConvert,
            LocalVirtualKeyCode::NumpadComma => VirtualKeyCode::NumpadComma,
            LocalVirtualKeyCode::NumpadEnter => VirtualKeyCode::NumpadEnter,
            LocalVirtualKeyCode::NumpadEquals => VirtualKeyCode::NumpadEquals,
            LocalVirtualKeyCode::OEM102 => VirtualKeyCode::OEM102,
            LocalVirtualKeyCode::Period => VirtualKeyCode::Period,
            LocalVirtualKeyCode::PlayPause => VirtualKeyCode::PlayPause,
            LocalVirtualKeyCode::Power => VirtualKeyCode::Power,
            LocalVirtualKeyCode::PrevTrack => VirtualKeyCode::PrevTrack,
            LocalVirtualKeyCode::RAlt => VirtualKeyCode::RAlt,
            LocalVirtualKeyCode::RBracket => VirtualKeyCode::RBracket,
            LocalVirtualKeyCode::RControl => VirtualKeyCode::RControl,
            LocalVirtualKeyCode::RMenu => VirtualKeyCode::RMenu,
            LocalVirtualKeyCode::RShift => VirtualKeyCode::RShift,
            LocalVirtualKeyCode::RWin => VirtualKeyCode::RWin,
            LocalVirtualKeyCode::Semicolon => VirtualKeyCode::Semicolon,
            LocalVirtualKeyCode::Slash => VirtualKeyCode::Slash,
            LocalVirtualKeyCode::Sleep => VirtualKeyCode::Sleep,
            LocalVirtualKeyCode::Stop => VirtualKeyCode::Stop,
            LocalVirtualKeyCode::Subtract => VirtualKeyCode::Subtract,
            LocalVirtualKeyCode::Sysrq => VirtualKeyCode::Sysrq,
            LocalVirtualKeyCode::Tab => VirtualKeyCode::Tab,
            LocalVirtualKeyCode::Underline => VirtualKeyCode::Underline,
            LocalVirtualKeyCode::Unlabeled => VirtualKeyCode::Unlabeled,
            LocalVirtualKeyCode::VolumeDown => VirtualKeyCode::VolumeDown,
            LocalVirtualKeyCode::VolumeUp => VirtualKeyCode::VolumeUp,
            LocalVirtualKeyCode::Wake => VirtualKeyCode::Wake,
            LocalVirtualKeyCode::WebBack => VirtualKeyCode::WebBack,
            LocalVirtualKeyCode::WebFavorites => VirtualKeyCode::WebFavorites,
            LocalVirtualKeyCode::WebForward => VirtualKeyCode::WebForward,
            LocalVirtualKeyCode::WebHome => VirtualKeyCode::WebHome,
            LocalVirtualKeyCode::WebRefresh => VirtualKeyCode::WebRefresh,
            LocalVirtualKeyCode::WebSearch => VirtualKeyCode::WebSearch,
            LocalVirtualKeyCode::WebStop => VirtualKeyCode::WebStop,
            LocalVirtualKeyCode::Yen => VirtualKeyCode::Yen,
        }
    }
}
